'  SPIN 8-bit WAV Player Ver. 1a  (Plays only mono 8-bit WAV at 8 or 16 ksps)
'  Copyright 2007 Raymond Allen  See end of file for terms of use.


'modified by clock loop for sustained and short whisle generator and putty diag output

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000       '80 MHz

  Rx        = 31     'serial in from wx device
  Tx        = 30     'serial out to wx device
  
OBJ
  ser: "Parallax Serial Terminal.spin"
    
  
VAR
  long  SmokeStack1[50]

PUB Main | loopcount
  'Play a WAV File

    ser.StartRxTx(RX, TX, 0, 115200)   'Cog #3  Parallax Serial Terminal does NOT work at receiving data 230400 for some reason.
    waitcnt(10_000_000 + cnt)   'wait 1/8 second for serial to start.

    ser.str(string(27))     'Set command mode ANSI command for putty terminal program.                                                    
    ser.str(string("[2J"))  'Clear telnet screen.
                           
    ser.str(string(27))      'Set command mode 
    ser.str(string("[1;1f")) 'Set Position  

  Pwm := 0

    
  cognew(WhistleSustain, @SmokeStack1)   '


Repeat
        If Pwm == 100 or Pwm == 0
          Repeat 10
            waitcnt(80_000_000 + cnt)
            Sustain := 1
        
        If Pwm == 25 or Pwm == 75
          Short := 1

        Sustain := 0    
       
        waitcnt(80_000_000 + cnt)   '
               
        If Dir == 0                
            'Repeat 3
            Pwm++
            If Pwm > 99
              dir := 1
              Pwm := 100
        Else
            'Repeat 3
            Pwm--
            If Pwm < 1
              dir := 0
              Pwm := 0
        
    
   

PUB Player(pWav, PinR, PinL, rate1):bOK|b,n,i,nextCnt,rate,dcnt
  'Play the wav data using counter modules
  'although just mono, using both counters to play the same thing on both left and right pins

  'Set pins to output mode
  DIRA[PinR]~~                              'Set Right Pin to output
  DIRA[PinL]~~                              'Set Left Pin to output

  'Set up the counters
  CTRA:= %00110 << 26 + 0<<9 + PinR         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)
  CTRB:= %00110 << 26 + 0<<9 + PinL         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)

  'get length
  n:=long[pWav+40]
  'get rate
  rate:=long[pWav+24]
  case rate
    8000:
      dcnt:=10000
    16000:
      dcnt:=5000
      'dcnt:=2000
    other:
      return false
  'jump over header
  dcnt:=rate1
  pWav+=44   'ignore rest of header (so you better have the right file format!)


  'Get ready for fast loop
  n--
  nLength := n
  i:=0
  NextCnt:=cnt+15000

  'Play loop
  repeat i from b to n
    
    If i > 6_000 And Short == 1
      i := 27_000
      Short := 0
     
    If i > 26_000 And Sustain == 1
      RevSw := 1
      b := n
      n := 0
      
    If i < 14_000 And RevSw == 1
      RevSw := 0
      n := b
      b := 0    
    
    NextCnt+=dcnt   ' need this to be 5000 for 16KSPS   @ 80 MHz
    waitcnt(NextCnt)
    FRQA:=(byte[pWav+i])<<24
    FRQB:=FRQA


      'Easy high-impedance output (e.g., to "line in" input of computer or sound system)
      '
      '              R=100
      ' Prop Pin ────┳──────── Audio Out
       '               C=0.1uF
       '                
       '               Vss
  return true
 
        
PUB WhistleSustain
  

  Repeat

        ser.str(string(27))      'Set command mode 
        ser.str(string("[8;3f")) 'Set Position
        ser.Str(string("Pwm:    "))
        ser.dec(Pwm)
        ser.Str(string("            ")) 
      
        ser.str(string(27))      'Set command mode 
        ser.str(string("[9;3f")) 'Set Position
        ser.Str(string("Length:    "))
        ser.dec(nLength)
        ser.Str(string("            ")) 

      If Pwm == 0 or Pwm == 100 or Pwm == 50 or Pwm == 25 or Pwm == 75
             
        Player(@Whistle,-1,27,10_000)


        
DAT

RevSw         byte 0
RevBit        byte 0
Sustain       byte 0
nLength       long 0
Pwm           byte 0
Dir           byte 0
Short         byte 0

Whistle long
File "Lwstl.wav"

{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
